package gocli

import (
	"bytes"
	"encoding/json"
	"net/http"
)

var Basepath string = ""
var Host string = ""
var ExtraHeaders map[string]string = make(map[string]string)

func invoke(m string, path string, bodyo interface{}) (*json.Decoder, error) {

	b := &bytes.Buffer{}
	err := json.NewEncoder(b).Encode(bodyo)
	if err != nil {
		return nil, err
	}
	body := bytes.NewReader(b.Bytes())

	req, err := http.NewRequest(m, Host+Basepath+path, body)
	if err != nil {
		return nil, err
	}

	req.Header.Set("Content-type", "application/json")
	for k, v := range ExtraHeaders {
		req.Header.Set(k, v)
	}
	cli := http.Client{}
	res, err := cli.Do(req)
	if err != nil {
		return nil, err
	}
	ret := json.NewDecoder(res.Body)
	return ret, nil
}

type AStr struct {
	A string `json:"a"`
}

func SomeAPI2(req *AStr) (res []*AStr, err error) {
	dec, err := invoke("POST", "/someapi", req)
	ret := []*AStr{}
	err = dec.Decode(ret)
	if err != nil {
		return nil, err
	}
	return ret, err
}
